// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from soccer_geometry_msgs:msg/PointWithCovariance.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "soccer_geometry_msgs/msg/point_with_covariance.hpp"


#ifndef SOCCER_GEOMETRY_MSGS__MSG__DETAIL__POINT_WITH_COVARIANCE__TRAITS_HPP_
#define SOCCER_GEOMETRY_MSGS__MSG__DETAIL__POINT_WITH_COVARIANCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "soccer_geometry_msgs/msg/detail/point_with_covariance__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'point'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace soccer_geometry_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PointWithCovariance & msg,
  std::ostream & out)
{
  out << "{";
  // member: point
  {
    out << "point: ";
    to_flow_style_yaml(msg.point, out);
    out << ", ";
  }

  // member: covariance
  {
    if (msg.covariance.size() == 0) {
      out << "covariance: []";
    } else {
      out << "covariance: [";
      size_t pending_items = msg.covariance.size();
      for (auto item : msg.covariance) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PointWithCovariance & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: point
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "point:\n";
    to_block_style_yaml(msg.point, out, indentation + 2);
  }

  // member: covariance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.covariance.size() == 0) {
      out << "covariance: []\n";
    } else {
      out << "covariance:\n";
      for (auto item : msg.covariance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PointWithCovariance & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace soccer_geometry_msgs

namespace rosidl_generator_traits
{

[[deprecated("use soccer_geometry_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const soccer_geometry_msgs::msg::PointWithCovariance & msg,
  std::ostream & out, size_t indentation = 0)
{
  soccer_geometry_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use soccer_geometry_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const soccer_geometry_msgs::msg::PointWithCovariance & msg)
{
  return soccer_geometry_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<soccer_geometry_msgs::msg::PointWithCovariance>()
{
  return "soccer_geometry_msgs::msg::PointWithCovariance";
}

template<>
inline const char * name<soccer_geometry_msgs::msg::PointWithCovariance>()
{
  return "soccer_geometry_msgs/msg/PointWithCovariance";
}

template<>
struct has_fixed_size<soccer_geometry_msgs::msg::PointWithCovariance>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Point>::value> {};

template<>
struct has_bounded_size<soccer_geometry_msgs::msg::PointWithCovariance>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Point>::value> {};

template<>
struct is_message<soccer_geometry_msgs::msg::PointWithCovariance>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SOCCER_GEOMETRY_MSGS__MSG__DETAIL__POINT_WITH_COVARIANCE__TRAITS_HPP_
